package app;

import org.apache.storm.Config;
import org.apache.storm.LocalCluster;
import org.apache.storm.topology.TopologyBuilder;


public class SaleTopology {

    static String dataFile;
    static String resultFile;

    public static void main(String args[]) throws Exception {

        dataFile = "./data_"+args[0]+".csv";
        resultFile = "./result_"+args[0]+".csv";

        System.out.println("-->> Start SaleFinderTopology with Data File : "+dataFile);
        TopologyBuilder topologyBuilder = new TopologyBuilder();
        topologyBuilder.setSpout("sale-reader", new SaleSpout());
        topologyBuilder.setBolt("sale-finder", new SaleBolt(), 1).shuffleGrouping("sale-reader");
        Config config = new Config();
        config.setDebug(true);
        LocalCluster localCluster = new LocalCluster();

        localCluster.submitTopology("sale-finder-topology", config, topologyBuilder.createTopology());
        try { Thread.sleep(10000); } catch (Exception e) { }
        localCluster.shutdown();

        System.out.println("-->> End SaleFinderTopology with Result File : "+resultFile);
        System.exit(0);
    }


}